/*
Author: Pierluigi Pesenti	
Blog: http://blog.oaxoa.com/

Flash player 10 required.
*/

package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.GlowFilter;
	[SWF(width="400", height="600", backgroundColor=0x000033, frameRate="60")]
	
	public class Xmas2009 extends Sprite {
		private var lights:Sprite;
		private const INIT_RADIUS:Number=150;
		private const MAX_ROTATION_X:Number=20;
		
		[Embed(source="lights.swf", symbol="light1")] private var light1_class:Class;
		[Embed(source="lights.swf", symbol="light2")] private var light2_class:Class;
		[Embed(source="lights.swf", symbol="light3")] private var light3_class:Class;
		[Embed(source="lights.swf", symbol="light4")] private var light4_class:Class;

		public function Xmas2009() {
			
			lights=new Sprite();
			lights.x=200;
			lights.y=250;
			lights.filters=[new GlowFilter(0xffcc00, 1, 12, 12, 2, 1)];
			
			prepare(light1_class, lights, 170, 18, 120);
			prepare(light2_class, lights, 100, 2, 20);
			prepare(light4_class, lights, 100, 2, 20, 180);
			prepare(light3_class, lights, 160, 31, 50);
			
			addChild(lights);
			addEventListener(Event.ENTER_FRAME, onframe);
		}
		private function onframe(event:Event):void {
			var sy:Number=(mouseX-200)/80;		
			lights.rotationY+=sy;
			correctOrientations(lights);
		}
		private function correctOrientations($target:Sprite):void {
			var c:Sprite;
			for(var i:uint=0; i<$target.numChildren; i++) {
				c=$target.getChildAt(i) as Sprite;
				c.rotationY=-$target.rotationY;
				c.rotationX=-$target.rotationX;
			}
		}
		public function prepare(className:Class, target:Sprite, count:uint, revolutions:uint, lightInterval:uint, initialAngle:Number=0):void {
			var a:Number=initialAngle;
			var arad:Number, l:Light, yspan:Number, r:Number;
			
			for (var i:int=0; i<count; i++) {
				r=INIT_RADIUS/count*i;
				a+=(360*revolutions)/count;
				arad=a/180*Math.PI;
				
				l=new Light(className, lightInterval*i); 
				l.x=Math.cos(arad)*r;
				yspan=400/count;
				l.y=i*yspan-200;
				l.z=Math.sin(arad)*r;
				target.addChild(l);
			}
		}
	}
}